\usepackage[utf8]{inputenc}
\usepackage[french]{babel}
\usepackage[T1]{fontenc}
\usepackage{amsmath, amsfonts, amssymb, amsthm}
\usepackage{graphicx}
\usepackage{hyperref}
\usepackage[a4paper, margin=2.5cm]{geometry}

% quantum stuff

\usepackage{physics}  % bra-ket notation
\usepackage{mathrsfs} % hadamard h notation
\usepackage{qcircuit}

% listings

\usepackage{listings}
\usepackage{xcolor}
\usepackage{GoMono}

\definecolor{red}      {RGB}{235,  77,  75}
\definecolor{green}    {RGB}{54,  166,  91}
\definecolor{yellow}   {RGB}{246, 199,  68}
\definecolor{blue}     {RGB}{134, 186, 235}
\definecolor{magenta}  {RGB}{164, 125, 233}
\definecolor{lightgrey}{RGB}{119, 119, 119}
\definecolor{grey}     {RGB}{48,   48,  48}

\lstdefinestyle{mstyle}{
    commentstyle=\color{grey},
    numberstyle=\tiny\color{codegray},
    stringstyle=\color{yellow},
    keywordstyle=[1]\color{magenta},
    keywordstyle=[2]\color{magenta},
    basicstyle=\ttfamily\footnotesize,
    breakatwhitespace=false,
    breaklines=true,
    captionpos=b,
    numbers=none,
    numbersep=5pt,
    showspaces=false,
    showstringspaces=false,
    showtabs=false,
    tabsize=2
}

\lstset{style=mstyle}

\theoremstyle{definition}
\newtheorem{ex}{Exercice}
\newcommand{\exa}{\underline{\textbf{Exemple:}} }
